<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PaycheckJournalDeductionList StructType
 * @subpackage Structs
 */
class PaycheckJournalDeductionList extends AbstractStructBase
{
    /**
     * The paycheckJournalDeduction
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\PaycheckJournalDeduction[]
     */
    public $paycheckJournalDeduction;
    /**
     * The replaceAll
     * Meta information extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $replaceAll;
    /**
     * Constructor method for PaycheckJournalDeductionList
     * @uses PaycheckJournalDeductionList::setPaycheckJournalDeduction()
     * @uses PaycheckJournalDeductionList::setReplaceAll()
     * @param \StructType\PaycheckJournalDeduction[] $paycheckJournalDeduction
     * @param bool $replaceAll
     */
    public function __construct(array $paycheckJournalDeduction = array(), $replaceAll = true)
    {
        $this
            ->setPaycheckJournalDeduction($paycheckJournalDeduction)
            ->setReplaceAll($replaceAll);
    }
    /**
     * Get paycheckJournalDeduction value
     * @return \StructType\PaycheckJournalDeduction[]|null
     */
    public function getPaycheckJournalDeduction()
    {
        return $this->paycheckJournalDeduction;
    }
    /**
     * This method is responsible for validating the values passed to the setPaycheckJournalDeduction method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPaycheckJournalDeduction method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePaycheckJournalDeductionForArrayConstraintsFromSetPaycheckJournalDeduction(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $paycheckJournalDeductionListPaycheckJournalDeductionItem) {
            // validation for constraint: itemType
            if (!$paycheckJournalDeductionListPaycheckJournalDeductionItem instanceof \StructType\PaycheckJournalDeduction) {
                $invalidValues[] = is_object($paycheckJournalDeductionListPaycheckJournalDeductionItem) ? get_class($paycheckJournalDeductionListPaycheckJournalDeductionItem) : sprintf('%s(%s)', gettype($paycheckJournalDeductionListPaycheckJournalDeductionItem), var_export($paycheckJournalDeductionListPaycheckJournalDeductionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The paycheckJournalDeduction property can only contain items of type \StructType\PaycheckJournalDeduction, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set paycheckJournalDeduction value
     * @throws \InvalidArgumentException
     * @param \StructType\PaycheckJournalDeduction[] $paycheckJournalDeduction
     * @return \StructType\PaycheckJournalDeductionList
     */
    public function setPaycheckJournalDeduction(array $paycheckJournalDeduction = array())
    {
        // validation for constraint: array
        if ('' !== ($paycheckJournalDeductionArrayErrorMessage = self::validatePaycheckJournalDeductionForArrayConstraintsFromSetPaycheckJournalDeduction($paycheckJournalDeduction))) {
            throw new \InvalidArgumentException($paycheckJournalDeductionArrayErrorMessage, __LINE__);
        }
        $this->paycheckJournalDeduction = $paycheckJournalDeduction;
        return $this;
    }
    /**
     * Add item to paycheckJournalDeduction value
     * @throws \InvalidArgumentException
     * @param \StructType\PaycheckJournalDeduction $item
     * @return \StructType\PaycheckJournalDeductionList
     */
    public function addToPaycheckJournalDeduction(\StructType\PaycheckJournalDeduction $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PaycheckJournalDeduction) {
            throw new \InvalidArgumentException(sprintf('The paycheckJournalDeduction property can only contain items of type \StructType\PaycheckJournalDeduction, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->paycheckJournalDeduction[] = $item;
        return $this;
    }
    /**
     * Get replaceAll value
     * @return bool|null
     */
    public function getReplaceAll()
    {
        return $this->replaceAll;
    }
    /**
     * Set replaceAll value
     * @param bool $replaceAll
     * @return \StructType\PaycheckJournalDeductionList
     */
    public function setReplaceAll($replaceAll = true)
    {
        // validation for constraint: boolean
        if (!is_null($replaceAll) && !is_bool($replaceAll)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($replaceAll, true), gettype($replaceAll)), __LINE__);
        }
        $this->replaceAll = $replaceAll;
        return $this;
    }
}
